var express = require("express");
const Order = require("../../app/Order");
const Manual = require("../../app/payment_processor/Manual");
const config = require("config");
var router = express.Router({ mergeParams: true });

router.use("/", (req, res, next) => {
  if (req.data && req.data.checkout) {
    req.data.checkout.payment = {
      provider: "manual",
    };
  }
  req.data.css.push(`${res.locals.baseDir}/styles/key/checkout-manual.css`);
  // Make sure only development environments can use this routes
  if (process.env.NODE_ENV !== "development") {
    throw "Manual Payments only allowed in development environment.";
  } else {
    next();
  }
});

router.get("/", (req, res) => {
  res.render("key", req.data);
});

router.post("/", (req, res) => {
  /**
   * @type {Order}
   */
  let new_order = null;
  Order.CREATE_NEW_ORDER(
    req.params.amount,
    req.data.key.key.get_key(),
    new Manual(req.body.note),
    req.t
  )
    .then((order) => {
      new_order = order;
      return order.captureOrder();
    })
    .then(() => new_order.chargeKey())
    .then(() => {
      let redirect_url =
        `${res.locals.baseDir}/key/` +
        req.data.key.key.get_key() +
        "/orders/" +
        new_order.getOrderID();
      res.redirect(redirect_url);
    });
});

module.exports = router;
